/****
*Author Javier Pena
*Date April 30, 2016
*
*/

#include <stdio.h>
#include <stdlib.h>
#include <sys/wait.h>
#include "parser.h"
#include "chop_line.h"
#include "list.h"


void sigchildHandler(int sig)
{
  int status;
  int pid;
  while((pid = waitpid(-1,&status,WNOHANG))>0)
	{
	  if(WIFEXITED(status))
		printf("SIMSH3 child %d terminated with status %d\n",pid,WEXITSTATUS(status));
	  else
		printf("SIMSH3 child %d terminated abnormally\n",pid);
	}
	 
  return;
}


int main(int argc, char **argv)
{
  pid_t child;
  int running = 1;
  int listSize;
  signal(SIGCHLD, sigchildHandler);
  list_t *cmdList = list_create();

	while(running)
	  {
		int status=0;
		printf("simsh>");
		chopped_line_t *cl = readLine();
		listSize = parse(cmdList, cl);
		if(listSize>0)
		  {
/* if background command*/
			if(cmdList->head->val->bg)
			  {
				//	  printf("has operator\n");
				if((child = fork())==0)
				  {
					//printf("in child fork simsh1 - process group = %d\n",getpgrp());
					status = executeCMD(cmdList,listSize);
					/* printf("exit1 status of cmd = %d\n",WIFEXITED(status)); */
					list_clear(cmdList);
					exit(-1);
				  }
			  }
			/*else execute if foreground*/
			else
			  {
				//				printf("in simsh1 - process group = %d\n",getpgrp());
				status = executeCMD(cmdList, listSize);
				list_clear(cmdList);
				/* printf("exit1 status of cmd = %d\n",WIFEXITED(status)); */
			  }
		  }
	  }
  }
